local ExPack = LibStub("AceAddon-3.0"):GetAddon("ExPack")
local PluginElvUI = ExPack:NewModule("PluginElvUI")
local Utils = ExPack:GetModule("Utils")

function PluginElvUI:Init(repo, config)
  local E, L, V, P, G = unpack(ElvUI)
  local Bags = E:GetModule("Bags")

  -- Initialize the default plugin as a fallback if ElvUI's bag module is disabled and
  -- the default bags are used
  self.default = ExPack:GetModule("PluginDefault")
  self.default:Init()

  hooksecurefunc(Bags, "UpdateSlot", function(self, frame, bagID, slotID)
    local bag = frame.Bags[bagID]
    local slot = bag and bag[slotID]
    ExPack:UpdateSlot(bagID, slot)
  end)

end

function PluginElvUI:GetSlotFrame(bagID, slotIndex)
  local containerFrameIndex

  if Utils:IsClassic() then
    containerFrameIndex = bagID - 1
  else
    containerFrameIndex = bagID
  end

  local itemIndex = slotIndex

  local customFrame = _G["ElvUI_ContainerFrameBag" .. containerFrameIndex .. "Slot" .. itemIndex]

  if customFrame then
    return customFrame
  else
    return self.default:GetSlotFrame(bagID, slotIndex)
  end
end
